# emacs-mode: -*- python-*-
import socket
import runtime
import evas
import os
import os.path
import sys
import status
import config
import utils
import tiservice
import update
class Tr069If:
    __module__ = __name__
    SOCK_FILE = '/tmp/.tr069.sock'

    def __init__(self):
        try:
            os.unlink(self.SOCK_FILE)
        except OSError:
            pass
        self.server_s = socket.socket(socket.AF_UNIX, socket.SOCK_STREAM, 0)
        self.server_s.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        self.server_s.bind(self.SOCK_FILE)
        self.server_s.listen(5)
        self.server_tag = utils.Input(self.server_s.fileno(), self.accept_tr069)
        print 'tr069 start'
        self.pid = os.fork()
        if (not self.pid):
            cmd = ('dimclient')
            os.execlp(cmd[0], *cmd)
            sys._exit(1)



    def accept_tr069(self, fd, type):
        print ''
        print '==================================='
        print ('accept_tr069. fd = %d, type = %d' % (fd,
         type))
        print '==================================='
        print ''
        assert (type == evas.INPUT_READ)
        (self.tr069_s, addr,) = self.server_s.accept()
        self.tr069_tag = utils.Input(self.tr069_s.fileno(), self.handle_tr069)
        return True



    def recv_packet(self):
        c = self.tr069_s.recv(1)
        l = ord(c)
        print 'l = ',
        print l
        msg = ''
        while (l > 0):
            m = self.tr069_s.recv(l)
            l -= len(m)
            msg += m

        print ''
        print '==================================='
        print ('recv_packet. msg = %s' % msg)
        print '==================================='
        print ''
        return msg



    def send_packet(self, buf):
        import struct
        p = struct.pack('B', len(buf))
        self.tr069_s.send(p)
        self.tr069_s.send(buf)



    def handle_tr069(self, fd, type):
        print ('handle_tr069. fd = %d, type = %d' % (fd,
         type))
        if (type & evas.INPUT_HUP):
            runtime.manager.handle_tr069_message('connection_closed')
            return False
        assert (type & evas.INPUT_READ)
        try:
            receive = self.recv_packet()
            print receive
            if (receive == 'set_stun_enable'):
                receive = self.recv_packet()
                print 'set stun server',
                print receive
            elif (receive == 'get_stun_enable'):
                self.send_packet('enable')
            elif (receive == 'set_stun_server_address'):
                receive = self.recv_packet()
                print 'stun server address',
                print receive
            elif (receive == 'get_stun_server_address'):
                self.send_packet('100.100.100.100')
            elif (receive == 'set_stun_server_port'):
                receive = self.recv_packet()
                print 'stun server port',
                print receive
            elif (receive == 'get_stun_server_port'):
                self.send_packet('1000')
            elif (receive == 'set_x_telecomitalia_it_info'):
                receive = self.recv_packet()
                print 'x_telecomitalia_it_info',
                print receive
            elif (receive == 'get_x_telecomitalia_it_info'):
                self.send_packet('hardware available and lock video')
            elif (receive == 'set_ip_address'):
                receive = self.recv_packet()
                print 'set_ip_address',
                print receive
            elif (receive == 'get_ip_address'):
                self.send_packet('100.100.100.100')
            elif (receive == 'set_subnetmask'):
                receive = self.recv_packet()
                print 'set_subnetmask',
                print receive
            elif (receive == 'get_subnetmask'):
                self.send_packet('255.255.255.0')
            elif (receive == 'set_default_gateway'):
                receive = self.recv_packet()
                print 'set_default_gateway',
                print receive
            elif (receive == 'get_default_gateway'):
                self.send_packet('100.100.100.100')
            elif (receive == 'set_dns_server'):
                receive = self.recv_packet()
                print 'set_dns_server',
                print receive
            elif (receive == 'get_dns_server'):
                self.send_packet('100.100.100.100')
            elif (receive == 'get_media_type'):
                self.send_packet('80211b')
            elif (receive == 'get_media_status'):
                self.send_packet('true')
            elif (receive == 'get_voice_service_number_of_entries'):
                self.send_packet('10')
            elif (receive == 'get_x_telecomitalia_it_vidserentries'):
                self.send_packet('10')
            elif (receive == 'get_voice_profile_number_of_entries'):
                self.send_packet('10')
            elif (receive == 'set_voice_profile_enable'):
                receive = self.recv_packet()
                print 'set_voice_profile_enable',
                print receive
            elif (receive == 'get_voice_profile_enable'):
                self.send_packet('Enabled')
            elif (receive == 'set_sip_user_agent_domain'):
                receive = self.recv_packet()
                print 'set_sip_user_agent_domain',
                print receive
                tiservice.setSipDomain(receive)
            elif (receive == 'get_sip_user_agent_domain'):
                from vdcisetting import vdcisetting
                self.send_packet(vdcisetting.domain)
            elif (receive == 'set_sip_user_agent_port'):
                receive = self.recv_packet()
                print 'set_sip_user_agent_port',
                print receive
            elif (receive == 'get_sip_user_agent_port'):
                self.send_packet('10000')
            elif (receive == 'set_sip_x_telecomitalia_it_auth_realm'):
                receive = self.recv_packet()
                print 'set_sip_x_telecomitalia_it_auth_realm',
                print receive
                tiservice.setauthRealm(receive)
            elif (receive == 'get_sip_x_telecomitalia_it_auth_realm'):
                self.send_packet('digest.telecomitalia.it')
            elif (receive == 'set_sip_outbound_proxy'):
                receive = self.recv_packet()
                print 'set_sip_outbound_proxy',
                print receive
                tiservice.setproxy(receive)
            elif (receive == 'get_sip_outbound_proxy'):
                from vdcisetting import vdcisetting
                self.send_packet(vdcisetting.proxyAddress)
            elif (receive == 'set_sip_outbound_proxy_port'):
                receive = self.recv_packet()
                print 'set_sip_outbound_proxy_port',
                print receive
            elif (receive == 'get_sip_outbound_proxy_port'):
                self.send_packet('5060')
            elif (receive == 'set_line_enable'):
                receive = self.recv_packet()
                print 'set_line_enable',
                print receive
            elif (receive == 'get_line_enable'):
                self.send_packet('Quiescent')
            elif (receive == 'set_line_directory_number'):
                receive = self.recv_packet()
                print 'set_line_directory_number',
                print receive
                try:
                    print 'CLI from TR069:',
                    print int(receive)
                    tiservice.setCli(receive)
                except:
                    print 'Invalid CLI from TR069:',
                    print receive
            elif (receive == 'get_line_directory_number'):
                from vdcisetting import vdcisetting
                self.send_packet(vdcisetting.CLI)
            elif (receive == 'set_line_sip_auth_username'):
                receive = self.recv_packet()
                print 'set_line_sip_auth_username',
                print receive
            elif (receive == 'get_line_sip_auth_username'):
                self.send_packet('username')
            elif (receive == 'set_line_sip_auth_password'):
                receive = self.recv_packet()
                print 'set_line_sip_auth_password',
                print receive
                tiservice.setSipkey(receive)
            elif (receive == 'get_line_sip_auth_password'):
                from vdcisetting import vdcisetting
                self.send_packet(vdcisetting.sipKey)
            elif (receive == 'set_video_profile_enable'):
                receive = self.recv_packet()
                print 'set_video_profile_enable',
                print receive
            elif (receive == 'get_video_profile_enable'):
                self.send_packet('Quiescent')
            elif (receive == 'check_call_status'):
                if (status.phone_status == status.Disconnected):
                    self.send_packet('true')
                else:
                    self.send_packet('false')
                    print 'Download interrupt: phone_status=',
                    print status.phone_status
            elif (receive == 'ip_download_finished'):
                receive = self.recv_packet()
                print receive
                if os.path.exists('/usr/local/update/lock'):
                    update.end_of_download(waitsec=receive)
                else:
                    print 'file not found'
            elif (receive == 'set_voice_profile_reset'):
                tiservice.InitializeCheckAPTCPforCLI()
            elif (receive == 'set_provisioning_code'):
                print 'set_provisionin_code, check /tmp/aptcp.xml in aptcp.py'
                tiservice.InitializeCheckTR069forCLI()
            elif (receive == 'set_url_data'):
                print 'set_url_data',
                print receive
                tiservice.InitializeCheckTR069forURL()
        except:
            pass
        return True




# local variables:
# tab-width: 4
